<?php

namespace app\index\controller;
use think\Controller;
use think\Db;
use think\Request;
class  TbPd extends Controller
{
    public function index() {
        $edate=date("Y-m-d");
        $sdate=date('Y-m-d',strtotime("$edate -1 month"));
        if (!empty($_GET['stime'])) {
            $sdate=$_GET['stime'];
        }
        if (!empty($_GET['etime'])) {
            $edate=substr($_GET['etime'],0,10);
            $edate=date("Y-m-d",strtotime("$edate +1 day"));
        }
        if (empty($_GET['id'])) die('无效的编号');
        $id = $_GET['id'];
        $warn=Db::table('warn_cfg')->where('eqmid',$id)->find();
        session('warn',$warn);
        $this->assign('warn',$warn);
        $data = Db::table('data_pd_h')->where('eqmid',$id)->where('d_time','between time',[$sdate,$edate])->order('d_time desc')->paginate(10,false,['query'=>request()->param(),]);
        $data1 = Db::table('data_pd_h')->where('eqmid',$id)->where('d_time','between time',[$sdate,$edate])->select();
        session('data',$data);
        session('data1',$data1);
        $this->assign('data',$data);
        return $this->fetch('tb_pd');
    }
    public function ExcelOne() {
        $list = session('data');
        $xlsCell  = array(
        array('d_time','时间'),
        array('padschalm','局部放电告警'),
        array('apppadsch','局放放电量'),
        array('padschtype','局部放电类型'),
        array('waveform','放电波型'),
        array('phase','放电相位'),
        array('plsnum','脉冲个数'),
        );
        $this->exportExcel("当前数据导出",$xlsCell,$list);
    }
    public function ExcelAll() {
        $list = session('data1');
        $xlsCell  = array(
        array('d_time','时间'),
        array('padschalm','局部放电告警'),
        array('apppadsch','局放放电量'),
        array('padschtype','局部放电类型'),
        array('waveform','放电波型'),
        array('phase','放电相位'),	
        array('plsnum','脉冲个数'),
        );
        $this->exportExcel("全部数据导出",$xlsCell,$list);
    }
    public function exportExcel($expTitle,$expCellName,$expTableData) {
        $xlsTitle = iconv('utf-8','gb2312',$expTitle);
        $fileName = $expTitle.date('_YmdHis');
        $cellNum = count($expCellName);
        $dataNum = count($expTableData);
        import('PhpExcel',EXTEND_PATH);
        $objPHPExcel = new \PhpExcel();
        $objWriter = new \PHPExcel_Writer_Excel5($objPHPExcel);
        $cellName = array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','AA','AB','AC','AD','AE','AF','AG','AH','AI','AJ','AK','AL','AM','AN','AO','AP','AQ','AR','AS','AT','AU','AV','AW','AX','AY','AZ');
        $objPHPExcel->getActiveSheet(0)->mergeCells('A1:'.$cellName[$cellNum-1].'1');
        for ($i=0;$i<$cellNum;$i++) {
            $objPHPExcel->getActiveSheet(0)->getColumnDimension($cellName[$i])->setWidth(18);
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cellName[$i].'2',$expCellName[$i][1]);
        }
        for ($i=0;$i<$dataNum;$i++) {
            for ($j=0;$j<$cellNum;$j++) {
                if($expTableData[$i]['padschalm']<session('warn.warnmin1') ||$expTableData[$i]['padschalm']>session('warn.warnmax1')) {
                        $objPHPExcel->getActiveSheet(0)->getStyle('B'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
                }
                if($expTableData[$i]['apppadsch']<session('warn.warnmin2') ||$expTableData[$i]['apppadsch']>session('warn.warnmax2')) {
                        $objPHPExcel->getActiveSheet(0)->getStyle('C'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
                }
                if($expTableData[$i]['padschtype']<session('warn.warnmin3') ||$expTableData[$i]['padschtype']>session('warn.warnmax3')) {
                        $objPHPExcel->getActiveSheet(0)->getStyle('D'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
                }
                if($expTableData[$i]['waveform']<session('warn.warnmin4') ||$expTableData[$i]['waveform']>session('warn.warnmax4')) {
                        $objPHPExcel->getActiveSheet(0)->getStyle('E'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
                }
                if($expTableData[$i]['phase']<session('warn.warnmin5') ||$expTableData[$i]['phase']>session('warn.warnmax5')) {
                        $objPHPExcel->getActiveSheet(0)->getStyle('F'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
                }
                if($expTableData[$i]['plsnum']<session('warn.warnmin6') ||$expTableData[$i]['plsnum']>session('warn.warnmax6')) {
                        $objPHPExcel->getActiveSheet(0)->getStyle('F'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
                }
                $objPHPExcel->getActiveSheet(0)->setCellValue($cellName[$j].($i+3),$expTableData[$i][$expCellName[$j][0]]);
            }
        }
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="'.$xlsTitle.'.xls"');
        header('Cache-Control: max-age=0');
        $objWriter->save('php://output');
        exit;	
    }
	

}

